org.jgroups.protocols

## Class SFC

- java.lang.Object
- - org.jgroups.stack.Protocol
  - - org.jgroups.protocols.SFC

- Deprecated.

      @Deprecated
      public class SFC
      extends Protocol

  Simple flow control protocol. After max_credits bytes sent to the group (or an individual member), the sender blocks until it receives an ack from all members that they indeed received max_credits bytes. Design in doc/design/SimpleFlowControl.txt
  Note that SFC supports only flow control for multicast messages; unicast flow control is not supported ! Use FC if unicast flow control is required.
  Author:
    Bela Ban

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `SFC.Header` Deprecated.

  - ### Field Summary

    - ### Fields inherited from class org.jgroups.stack.Protocol

      `down_prot, ergonomics, id, log, name, stack, stats, up_prot`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SFC()` Deprecated.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.Object` | `down(Event evt)` Deprecated. An event is to be sent down the stack.
    `double` | `getAverageBlockingTime()` Deprecated.
    `long` | `getBlockings()` Deprecated.
    `long` | `getBytesSent()` Deprecated.
    `long` | `getCreditRequestsReceived()` Deprecated.
    `long` | `getCreditRequestsSent()` Deprecated.
    `long` | `getCredits()` Deprecated.
    `long` | `getMaxCredits()` Deprecated.
    `long` | `getReplenishmentsReceived()` Deprecated.
    `long` | `getReplenishmentsSent()` Deprecated.
    `long` | `getTotalBlockingTime()` Deprecated.
    `void` | `init()` Deprecated. Called after instance has been created (null constructor) and before protocol is started.
    `java.lang.String` | `printBlockingTimes()` Deprecated.
    `java.lang.String` | `printPendingCreditors()` Deprecated.
    `java.lang.String` | `printPendingRequesters()` Deprecated.
    `java.lang.String` | `printReceived()` Deprecated.
    `void` | `resetStats()` Deprecated.
    `void` | `start()` Deprecated. This method is called on a `Channel.connect(String)`.
    `void` | `stop()` Deprecated. This method is called on a `Channel.disconnect()`.
    `void` | `unblock()` Deprecated.
    `java.lang.Object` | `up(Event evt)` Deprecated. An event was received from the layer below.

    - ### Methods inherited from class org.jgroups.stack.Protocol

      `destroy, downThreadEnabled, dumpStats, enableStats, getConfigurableObjects, getDownProtocol, getId, getLevel, getName, getProperties, getProtocolStack, getSocketFactory, getThreadFactory, getTransport, getUpProtocol, getValue, isErgonomics, printStats, providedDownServices, providedUpServices, requiredDownServices, requiredUpServices, setDownProtocol, setErgonomics, setId, setLevel, setProperties, setPropertiesInternal, setProperty, setProtocolStack, setSocketFactory, setUpProtocol, setValue, setValues, statsEnabled, upThreadEnabled`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SFC

          public SFC()

      Deprecated.

  - ### Method Detail

    - #### resetStats

          public void resetStats()

      Deprecated.
      Overrides:
        `resetStats` in class `Protocol`

    - #### getMaxCredits

          public long getMaxCredits()

      Deprecated.

    - #### getCredits

          public long getCredits()

      Deprecated.

    - #### getBytesSent

          public long getBytesSent()

      Deprecated.

    - #### getBlockings

          public long getBlockings()

      Deprecated.

    - #### getCreditRequestsSent

          public long getCreditRequestsSent()

      Deprecated.

    - #### getCreditRequestsReceived

          public long getCreditRequestsReceived()

      Deprecated.

    - #### getReplenishmentsReceived

          public long getReplenishmentsReceived()

      Deprecated.

    - #### getReplenishmentsSent

          public long getReplenishmentsSent()

      Deprecated.

    - #### getTotalBlockingTime

          public long getTotalBlockingTime()

      Deprecated.

    - #### getAverageBlockingTime

          public double getAverageBlockingTime()

      Deprecated.

    - #### printBlockingTimes

          public java.lang.String printBlockingTimes()

      Deprecated.

    - #### printReceived

          public java.lang.String printReceived()

      Deprecated.

    - #### printPendingCreditors

          public java.lang.String printPendingCreditors()

      Deprecated.

    - #### printPendingRequesters

          public java.lang.String printPendingRequesters()

      Deprecated.

    - #### unblock

          public void unblock()

      Deprecated.

    - #### down

          public java.lang.Object down(Event evt)

      Deprecated.
      Description copied from class: `Protocol`
      An event is to be sent down the stack. The layer may want to examine its type and perform some action on it, depending on the event's type. If the event is a message MSG, then the layer may need to add a header to it (or do nothing at all) before sending it down the stack using `down_prot.down()`. In case of a GET_ADDRESS event (which tries to retrieve the stack's address from one of the bottom layers), the layer may need to send a new response event back up the stack using `up_prot.up()`.
      Overrides:
        `down` in class `Protocol`

    - #### up

          public java.lang.Object up(Event evt)

      Deprecated.
      Description copied from class: `Protocol`
      An event was received from the layer below. Usually the current layer will want to examine the event type and - depending on its type - perform some computation (e.g. removing headers from a MSG event type, or updating the internal membership list when receiving a VIEW_CHANGE event). Finally the event is either a) discarded, or b) an event is sent down the stack using `down_prot.down()` or c) the event (or another event) is sent up the stack using `up_prot.up()`.
      Overrides:
        `up` in class `Protocol`

    - #### init

          public void init()
                    throws java.lang.Exception

      Deprecated.
      Description copied from class: `Protocol`
      Called after instance has been created (null constructor) and before protocol is started. Properties are already set. Other protocols are not yet connected and events cannot yet be sent.
      Overrides:
        `init` in class `Protocol`
      Throws:
        `java.lang.Exception` - Thrown if protocol cannot be initialized successfully. This will cause the ProtocolStack to fail, so the channel constructor will throw an exception

    - #### start

          public void start()
                     throws java.lang.Exception

      Deprecated.
      Description copied from class: `Protocol`
      This method is called on a `Channel.connect(String)`. Starts work. Protocols are connected and queues are ready to receive events. Will be called from bottom to top. This call will replace the START and START_OK events.
      Overrides:
        `start` in class `Protocol`
      Throws:
        `java.lang.Exception` - Thrown if protocol cannot be started successfully. This will cause the ProtocolStack to fail, so `Channel.connect(String)` will throw an exception

    - #### stop

          public void stop()

      Deprecated.
      Description copied from class: `Protocol`
      This method is called on a `Channel.disconnect()`. Stops work (e.g. by closing multicast socket). Will be called from top to bottom. This means that at the time of the method invocation the neighbor protocol below is still working. This method will replace the STOP, STOP_OK, CLEANUP and CLEANUP_OK events. The ProtocolStack guarantees that when this method is called all messages in the down queue will have been flushed
      Overrides:
        `stop` in class `Protocol`

Copyright © 1998-2009 Bela Ban / Red Hat. All Rights Reserved.